
type
  hex_str = string[2];	 { Result of byte-->hex conversion }
  track_event_type =		{ MPU-401 Track event type }
    (
    OVFL,				 { Timing Overflow }
    MARK,					{ MPU mark }
    MIDI,		 { MIDI using curr. running status }
    MIDI_RS,		 { MIDI setting new running status }
    UNKNOWN			   { Undefined track event }
    );
  track_event = 		      { Single track event }
    record
      time : byte;		     { Event relative time }
      mess : array[1..3] of byte;	 { Event directive }
    end;
  track_event_block =	  { Track event access environment }
    record
      running_status : byte;{ Current track running status }
      event_len : 1..4;{Event length,including timing byte }
      event_type : track_event_type;
      event : track_event;
    end;
  track_data_stream =	{ In memory track data stream file }
    array[1..TRACK_DATAFILE_SIZE] of byte;
  track_data_block ={ track data stream access environment }
    record
      tds : track_data_stream;		      { track data }
				 { track data read pointer } 
      tds_ptr : 1..TRACK_DATAFILE_SIZE; 
      edat : boolean;	     { indicates end of track data }
      curr : track_event_block;      { current track event }
    end;

const

			   { Track overflow event constant }
  OVFL_EVENT : track_event_block =  
    (			   { used to insert timing spacers }
    running_status:0;		  { into Track Data Stream }
    event_len:1;
    event_type:OVFL;
    event:
      (
      time:MAX_TIMING_COUNT;
      mess:(0,0,0)
      )
    );

 event_len:1;
    event_type:OVFL;
    event:
      (
      time:MAX_TIMING_COUNT;
      mess:(0,0,0)
   