/*
*****************************************************************************
file :   LISTTX81.C
date :   7/20/88

List voice names from a TX81Z bank file (MIDIEX format)
*****************************************************************************
*/

#include <ctype.h>
#include <fcntl.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <io.h>
#include <dos.h>
#include <process.h>
#include <stdio.h>

typedef unsigned char	BYTE;

#define TRUE		1
#define FALSE		0

#define BUFMAX		16834

#define SYSEX		0xF0

BYTE dump_buf[BUFMAX];

/*
=============================================================================
=============================================================================
*/
void main (argc, argv)
int   argc     ;
char  *argv[]  ;
   {
   int   i, j, k     ;
   int   file, size  ;

   /* open file & read data ---------------------------------------------- */
   if ((file = open (argv[1], (int)(O_RDONLY|O_BINARY))) < 0 )    {
   	printf ("\n***> Unable to open input file %s", argv[1])     ;
      exit (-1)         ;
      }

   if( (size = read(file, dump_buf, BUFMAX)) <= 0)    {
   	close (file)      ;
   	printf ("\n***> Trouble reading input file %s", argv[1])    ;
      exit (-1)         ;
      }

    close (file)        ;

   /* print voice names -------------------------------------------------- */
   printf ("\n\nfile: %s\n\n", argv[1])   ;

   for (i = 0 ; i < BUFMAX ; i++)
      if (dump_buf[i] == SYSEX)  break    ;  /* find sys exclusive byte */
   i = i + 63           ;  /* 1st voice name starts at 63 bytes after   */

   for (j = 0 ; j < 32 ; j++)
      printf ("   %.10s\n", &dump_buf[i+j*128])  ;

   exit (0)             ;
   }

